---
title: Build the brick field
slug: Games/Tutorials/2D_Breakout_game_pure_JavaScript/Build_the_brick_field
tags:
  - Beginner
  - Canvas
  - Games
  - Graphics
  - JavaScript
  - Tutorial
---
<div>{{GamesSidebar}}</div>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_pure_JavaScript/Game_over", "Games/Workflows/2D_Breakout_game_pure_JavaScript/Collision_detection")}}</p>

<div class="summary">
<p>This is the <strong>6th step</strong> out of 10 of the <a href="/en-US/docs/Games/Workflows/Breakout_game_from_scratch">Gamedev Canvas tutorial</a>. You can find the source code as it would look after completing this lesson at <a href="https://github.com/end3r/Gamedev-Canvas-workshop/blob/gh-pages/lesson06.html">Gamedev-Canvas-workshop/lesson6.html</a>.</p>
</div>

<p><span class="seoSummary">After modifying the gameplay mechanics, we are now able to lose — this is great as it means the game is finally feeling more like a game. However, it will quickly get boring if all you do is bounce the ball off the walls and the paddle. What a breakout game really needs is some bricks to destroy with the ball, and this is what we'll create now!</span></p>

<h2 id="Setting_up_the_brick_variables">Setting up the brick variables</h2>

<p>The overall aim of this lesson is to render a few lines of code for the  bricks, using a nested loop that works through a two-dimensional array. First however we need to set up some variables to define information about the bricks such as their width and height, rows and columns, etc. Add the following lines to your code below the variables which you have previously declared in your program.</p>

<pre class="brush: js notranslate">var brickRowCount = 3;
var brickColumnCount = 5;
var brickWidth = 75;
var brickHeight = 20;
var brickPadding = 10;
var brickOffsetTop = 30;
var brickOffsetLeft = 30;</pre>

<p>Here we've defined the number of rows and columns of bricks , their width and height, the padding between the bricks so they won't touch each other and a top and left offset so they won't start being drawn right from the edge of the Canvas.</p>

<p>We will hold all our bricks in a two-dimensional array. It will contain the brick columns (c), which in turn will contain the brick rows (r), which in turn will each contain an object containing the <code>x</code> and <code>y</code> position to paint each brick on the screen. Add the following just below your variables:</p>

<pre class="brush: js notranslate">var bricks = [];
for(var c=0; c&lt;brickColumnCount; c++) {
    bricks[c] = [];
    for(var r=0; r&lt;brickRowCount; r++) {
        bricks[c][r] = { x: 0, y: 0 };
    }
}</pre>

<p>The code above will loop through the rows and columns and create the new bricks. NOTE that the brick objects will also be used for collision detection purposes later.</p>

<h2 id="Brick_drawing_logic">Brick drawing logic</h2>

<p>Now let's create a function to loop through all the bricks in the array and draw them on the screen. Our code might look like this:</p>

<pre class="brush: js notranslate">function drawBricks() {
    for(var c=0; c&lt;brickColumnCount; c++) {
        for(var r=0; r&lt;brickRowCount; r++) {
            bricks[c][r].x = 0;
            bricks[c][r].y = 0;
            ctx.beginPath();
            ctx.rect(0, 0, brickWidth, brickHeight);
            ctx.fillStyle = "#0095DD";
            ctx.fill();
            ctx.closePath();
        }
    }
}</pre>

<p>Again, we're looping through the rows and columns to set the <code>x</code> and <code>y</code> position of each brick, and we're also painting a brick on the Canvas — size <code>brickWidth</code> x <code>brickHeight</code> — with each loop iteration. The problem is that we're painting them all in one place, at coordinates <code>(0,0)</code>. What we need to do is include some calculations that will work out the <code>x</code> and <code>y</code> position of each brick for each loop iteration:</p>

<pre class="brush: js notranslate">var brickX = (c*(brickWidth+brickPadding))+brickOffsetLeft;
var brickY = (r*(brickHeight+brickPadding))+brickOffsetTop;</pre>

<p>Each <code>brickX</code> position is worked out as <code>brickWidth</code> + <code>brickPadding</code>, multiplied by the column number, <code>c</code>, plus the <code>brickOffsetLeft</code>; the logic for the brickY is identical except that it uses the values for row number, <code>r</code>, <code>brickHeight</code>, and <code>brickOffsetTop</code>. Now every single brick can be placed in its correct place row and column, with padding between each brick, drawn at an offset from the left and top canvas edges.</p>

<p>The final version of the <code>drawBricks()</code> function, after assigning the <code>brickX</code> and <code>brickY</code> values as the coordinates instead of <code>(0,0)</code> each time, will look like this — add this into your code below the <code>drawPaddle()</code> function:</p>

<pre class="brush: js notranslate">function drawBricks() {
    for(var c=0; c&lt;brickColumnCount; c++) {
        for(var r=0; r&lt;brickRowCount; r++) {
            var brickX = (c*(brickWidth+brickPadding))+brickOffsetLeft;
            var brickY = (r*(brickHeight+brickPadding))+brickOffsetTop;
            bricks[c][r].x = brickX;
            bricks[c][r].y = brickY;
            ctx.beginPath();
            ctx.rect(brickX, brickY, brickWidth, brickHeight);
            ctx.fillStyle = "#0095DD";
            ctx.fill();
            ctx.closePath();
        }
    }
}</pre>

<h2 id="Actually_drawing_the_bricks">Actually drawing the bricks</h2>

<p>The last thing to do in this lesson is to add a call to <code>drawBricks()</code> somewhere in the <code>draw()</code> function, preferably at the beginning, between the clearing of the Canvas and drawing the ball. Add the following just above the <code>drawBall()</code> call:</p>

<pre class="brush: js notranslate">drawBricks();
</pre>

<h2 id="Compare_your_code">Compare your code</h2>

<p>At this point, the game has got a little more interesting again  :</p>

<p>{{JSFiddleEmbed("https://jsfiddle.net/raymondjplante/Lu3vtejz/","","395")}}</p>

<div class="note">
<p>Exercise: Try changing the number of bricks in a row or a column, or their positions.</p>
</div>

<h2 id="Next_steps">Next steps</h2>

<p>So now we have bricks! But the ball isn't interacting with them at all — we'll change that as we continue to the seventh chapter: <a href="/en-US/docs/Games/Workflows/Breakout_game_from_scratch/Collision_detection">Collision detection</a>.</p>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_pure_JavaScript/Game_over", "Games/Workflows/2D_Breakout_game_pure_JavaScript/Collision_detection")}}</p>
